import json
from sys import argv

import Descriptor as desc

import StructGenerator as sg
from itertools import chain

from ConfigGenerator import ConfigGenerator

# fetch USB settings
usb_config_file_name = argv[1]
with open(usb_config_file_name, 'r') as usb_config_file:
    usb_config_data = usb_config_file.read()
usb_config = json.loads(usb_config_data)

cfggen = ConfigGenerator(usb_config)
cfggen.generate()

# devDesc = desc.DeviceDescriptor(usb_config)
# print(devDesc.print_assigment())
#
# strDesc = desc.StringDescriptor("Testdevice", "StrDevice")
# print(strDesc.print_assigment())

#intrec = sg.RecordFactory.create("num", "u32", 127)
#print(intrec.print_typedef("INT"))
# intrec = sg.RecordFactory.create([ "num", "u32", 127, ])
# print(intrec.print_typedef("INTINT"))
# #
# strrec = sg.RecordFactory.create("some_string", "str", "Some string")
# print(strrec.print_typedef("STR"))
#print(strrec.print_content())
#
# recs = [ intrec, strrec ]
#
# struct1 = sg.StructRecord("struct1", "struct struct 1", recs)
# struct2 = sg.StructRecord("struct2", "struct struct2", recs)
# print(struct2.print_typedef("struct2"))
#
# structrec = sg.StructRecord("object", "struct compound", [ struct1, struct2, *recs ])
# print(structrec.print_content())