#ifndef CORE_USB_USB_CORE_TYPES
#define CORE_USB_USB_CORE_TYPES

#include "usb_common_types.h"

/* USB linespeed */
typedef enum { USB_SPD_UNKNOWN = 0b00, USB_SPD_LOW = 0b01, USB_SPD_FULL = 0b11 } USB_Speed;

/* USB core state */
typedef struct
{
    uint8_t linespeed; // USB linespeed
} USB_CoreState;


#endif /* CORE_USB_USB_CORE_TYPES */
